// Supplementary Materials for the article
// "Neural Network for Low-Memory IoT Devices and MNIST Image Recognition Using Kernels Based on Logistic Map"
// Program for LogNNet network training and testing
// Author:  Andrei Velichko
// Institute of Physics and Technology, Petrozavodsk State University, 31 Lenina str., Petrozavodsk 185910, Russia
// velichko@petrsu.ru
// 20.08.2020

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Load_progress: TLabel;
    PaintBox3: TPaintBox;
    View_train: TButton;
    Edit1: TEdit;
    View_test: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Start_button: TButton;
    Label48: TLabel;
    Label47: TLabel;
    Epoch_number: TEdit;
    Label4: TLabel;
    Label34: TLabel;
    Edit3: TEdit;
    Label39: TLabel;
    Edit26: TEdit;
    Label50: TLabel;
    Edit28: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label43: TLabel;
    Label44: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Stop_button: TButton;
    Label8: TLabel;
    Instruction: TLabel;
    Label1: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label_Load_MNIST: TLabel;
    TabSheet2: TTabSheet;
    Load_mnist_button: TButton;
    Load_Tpattern_button: TButton;
    Label_Load_T: TLabel;
    Setting_Array_W1: TButton;
    Fh_activ_fun_parameters: TButton;
    EpochTraining: TButton;
    BackPropagation: TButton;
    Algorithm_3: TButton;
    Algorithm_2: TButton;
    Algorithm_1: TButton;
    Label_Setting_Array: TLabel;
    Label_Epoch_training: TLabel;
    Label_Alg_3: TLabel;
    Label_Alg_2: TLabel;
    Label_Alg_1: TLabel;
    Label_Fh_activ_fun_parameters: TLabel;
    P_number: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label_name: TLabel;
    TabSheet3: TTabSheet;
    Memo1: TMemo;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    procedure Load_mnist_buttonClick(Sender: TObject);
    procedure View_trainClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox3Paint(Sender: TObject);
    procedure View_testClick(Sender: TObject);
    procedure Load_Tpattern_buttonClick(Sender: TObject);
    procedure Start_buttonClick(Sender: TObject);
    procedure EpochTrainingClick(Sender: TObject);
    procedure BackPropagationClick(Sender: TObject);
    procedure Setting_Array_W1Click(Sender: TObject);
    procedure Fh_activ_fun_parametersClick(Sender: TObject);
    procedure Algorithm_3Click(Sender: TObject);
    procedure Stop_buttonClick(Sender: TObject);
    procedure Algorithm_2Click(Sender: TObject);
    procedure Algorithm_1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
N_test=10000;  // The number of elements in the test data array from the MNIST-10 database
N_train=60000; // The number of elements in the training data array from the MNIST-10
Y_max=784;     // The number of dots in the image of a handwritten digit
P_maximum=200; // Maximum number of neurons in the hidden layer
N_max=9;       // Numbering limit of output neurons 0..9

Type
InputData=array[0..Y_max] of byte;  // Input data type
InputData2=array[0..Y_max] of real; // Input data type after normalization
OutputData=array[0..N_max] of real; // Output data type
Hiddenlayer=array[0..P_maximum] of real; // Data type of the hidden layer

var
  Form1: TForm1;
  P_max:integer;
  Train_data:array[1..N_train]of InputData; // Training data array from the MNIST-10 database
  Train_label2:array[1..N_train] of OutputData;   // Array of training data labels
  Train_label:array[1..N_train] of byte;   // Array of training data labels
  Test_data:array[1..N_test] of InputData;  // Test data array from the MNIST-10 database
  Test_label:array[1..N_test] of byte; // Array of test data labels
  Y:InputData2;  // Array of input image data
  Sh,Sh_max,Sh_min,Usre:Hiddenlayer;  // Array of hidden layer data
  Sout,Err3:OutputData;   // Array of output layer data
  XX_mask:InputData;
  i,k,j,KX,ii,Kadr,z1,z2,Nom_tren,i_max:integer;
  VM, VMproect:array[1..Y_max,1..2] of integer;
  r,A,B:real;
  W1:array[0..Y_max,1..P_maximum] of real;  // Array of weights W1
  W1_alg2:array[0..Y_max] of real;  // An auxiliary array for calculating the weights W1 for Algorithm-2
  W1_alg1:real; // Auxiliary variable for calculating the weights W1 for Algorithm-1
  W2, dW2:array[0..P_maximum,0..N_max] of real;    // Array of weights W2
  Usred:double;
  Norma:real;

  xStream: TFileStream;
  xBuffer: Byte;
  Bitmap3:TBitmap;
  Maskk2:array[1..28,1..28] of byte; //For Drowing
  logFile:Text;
  Stop_View:boolean;
  SR: TSearchRec;
  SSS,SSS2:string;
  All_t:integer;
  old_time, old_time2,Sec1:TDateTime;
  myHour, myMin, mySec, myMilli : Word;
  Correct_test: integer;
  Accuracy:real;
  stop, LoadFirsttime_Mnist:boolean;
  okk:boolean;

implementation

{$R *.dfm}
procedure Zeroing;  // Zeroing used arrays.
begin
for i:=0 to  Y_max do Y[i]:=0;
for i:=0 to  P_maximum do Sh[i]:=0;
for i:=0 to  N_max do begin Sout[i]:=0; Err3[i]:=0; end;

for i:=0 to  Y_max do
  for j:=1 to  P_maximum  do W1[i,j]:=0;
for i:=0 to  P_maximum  do
  for j:=0 to  N_max do   begin W2[i,j]:=0;  dW2[i,j]:=0;end;

end;

procedure TForm1.Load_mnist_buttonClick(Sender: TObject);
begin

Load_mnist_button.Enabled:=false;
Label_Load_MNIST.Font.Color:=clAqua;  Application.ProcessMessages;
///////////Zeroing
for j:=1 to N_train do
begin
  Train_data[j][0]:=1; //Bias
  for i:=1 to  Y_max do  Train_data[j][i]:=0; //Zeroing
end;

for j:=1 to N_train do
  for i:=0 to  N_max do Train_label2[j,i]:=0;  //Zeroing

for j:=1 to N_train do Train_label[j]:=0;  //Zeroing

for j:=1 to N_test do
begin
  Test_data[j][0]:=1; //Bias
  for i:=1 to  Y_max do  Test_data[j][i]:=0; //Zeroing
end;

for j:=1 to N_test do Test_label[j]:=0;  //Zeroing


///////////

//Loading training data
xStream:=TFileStream.Create('Mnist\train-images.idx3-ubyte',fmOpenRead or fmShareDenyWrite);
for k:=1 to N_train do
begin
  xStream.Position:=16+(k-1)*784;
  for i:=1 to 28 do begin
    for j:=1 to 28 do
      begin
      xStream.ReadBuffer(xBuffer,1);
      Train_data[k][(j-1)*28+i]:=xBuffer;
      end;
  if (k mod 1000) =0  then begin Load_progress.Caption:='Loading Train Data '+inttostr(k); Application.ProcessMessages; end;
  end;
end;

xStream.Free;
xStream:=TFileStream.Create('Mnist\train-labels.idx1-ubyte',fmOpenRead or fmShareDenyWrite);
for k:=1 to N_train do
begin
 xStream.Position:=8+(k-1);
 xStream.ReadBuffer(xBuffer,1);
 Train_label2[k][xBuffer]:=1; //Array for train label
 Train_label[k]:=xBuffer; //Array for train label  2
 if (k mod 1000) =0  then begin Load_progress.Caption:='Loading Train Label '+inttostr(k);Application.ProcessMessages; end;
end;
xStream.Free;

xStream:=TFileStream.Create('Mnist\t10k-images.idx3-ubyte',fmOpenRead or fmShareDenyWrite);
for k:=1 to N_test do
begin
  xStream.Position:=16+(k-1)*784;
  for i:=1 to 28 do begin
    for j:=1 to 28 do begin
      xStream.ReadBuffer(xBuffer,1);
      Test_data[k][(j-1)*28+i]:=xBuffer;
      end;
  end;
   if (k mod 1000) =0  then begin Load_progress.Caption:='Loading Test Data '+inttostr(k);Application.ProcessMessages; end;
end;

xStream.Free;
xStream:=TFileStream.Create('Mnist\t10k-labels.idx1-ubyte',fmOpenRead or fmShareDenyWrite);
for k:=1 to N_test do
begin
 xStream.Position:=8+(k-1);
 xStream.ReadBuffer(xBuffer,1);
 Test_label[k]:=xBuffer;
 if (k mod 1000) =0  then begin Load_progress.Caption:='Loading Test Label '+inttostr(k);Application.ProcessMessages; end;
end;
xStream.Free;


Load_mnist_button.Enabled:=true;
LoadFirsttime_Mnist:=false;
Label_Load_MNIST.Font.Color:=clBlack;  Application.ProcessMessages;
View_train.Click;
end;

Procedure Draw_Digit;  //Drawing Digits
var
xxx:integer;
yyy:integer;
color:integer;
begin
with Bitmap3 do
begin
  Canvas.Pen.Color:=clWhite;

  for i:=1 to 28 do
  for j:=1 to 28 do
  begin
    color:=round(Maskk2[i,j]/(255/6));
    if color=6 then   Canvas.Brush.Color:=RGB(128, 17, 0);
    if color=5 then   Canvas.Brush.Color:=RGB(182, 34, 3);
    if color=4 then   Canvas.Brush.Color:=RGB(215, 53, 2);
    if color=3 then   Canvas.Brush.Color:=RGB(252, 100, 0);
    if color=2 then   Canvas.Brush.Color:=RGB(255, 117, 0);
    if color=1 then   Canvas.Brush.Color:=RGB(250, 192, 0);
    if color=0 then   Canvas.Brush.Color:=RGB(255, 255, 255);
    Canvas.Pen.Color:=clGreen;
    xxx:=round(280*(j-1)/28);
    yyy:=round((280)*(i-1)/28);
    Canvas.Rectangle(xxx,yyy,round(280*j/28),round((280)*(i)/28));
  end;

end;

Form1.PaintBox3.Canvas.Draw(0,0,Bitmap3);
end;

procedure TForm1.View_trainClick(Sender: TObject);//Starting of drawing of digits from training set
var
t1:integer;
begin
if LoadFirsttime_Mnist then Load_mnist_button.Click;

try
t1:=strtoint(edit1.Text);
 except
    on Exception : EConvertError do
      begin
      ShowMessage(Exception.Message);  t1:=22; edit1.Text:=inttostr(t1);
      end;
  end;

if (t1>N_train)or(t1<1) then begin t1:=22; edit1.Text:=inttostr(t1); end;
   for i:=1 to 28 do
    for j:=1 to 28 do
       Maskk2[i,j]:= Train_data[t1][(j-1)*28+i];
Label3.Caption:=inttostr( Train_label[t1]);
Draw_Digit;
end;



procedure TForm1.FormCreate(Sender: TObject); //Initialization of application form
begin
Tabsheet2.TabVisible:=false;
Tabsheet1.Show;
Sec1:=StrToTime('15:03:45')-StrToTime('15:03:43'); //Setting 2 second interval
LoadFirsttime_Mnist:=true;
Norma:=0.2;// learning rate

Bitmap3 := TBitmap.Create;
Bitmap3.Height:=Form1.PaintBox3.Height;
Bitmap3.Width:=Form1.PaintBox3.Width;
okk:=true;
//Checking databases for availability
if not FileExists('Mnist\t10k-images.idx3-ubyte') then okk:=false;
if not FileExists('Mnist\t10k-labels.idx1-ubyte') then okk:=false;
if not FileExists('Mnist\train-images.idx3-ubyte') then okk:=false;
if not FileExists('Mnist\train-labels.idx1-ubyte') then okk:=false;

if not okk then
begin
  Load_mnist_button.Enabled:=false;
  Load_Tpattern_button.Enabled:=false;
  Setting_Array_W1.Enabled:=false;
  Fh_activ_fun_parameters.Enabled:=false;
  EpochTraining.Enabled:=false;
  BackPropagation.Enabled:=false;
  Algorithm_3.Enabled:=false;
  Algorithm_2.Enabled:=false;
  Algorithm_1.Enabled:=false;
  Start_button.Enabled:=false;
  Stop_button.Enabled:=false;
  View_train.Enabled:=false;
  View_test.Enabled:=false;
  ShowMessage('Please download Mnist-10 database, see "Operations_manual.pdf"');
end;

end;

procedure TForm1.PaintBox3Paint(Sender: TObject);
begin
 Form1.PaintBox3.Canvas.Draw(0,0,Bitmap3);  //Redrawing the application form
end;

procedure TForm1.View_testClick(Sender: TObject); //Starting the drawing of digit from testing set
var
t1:integer;
begin
if LoadFirsttime_Mnist then Load_mnist_button.Click;

try
t1:=strtoint(edit2.Text);
  except
    on Exception : EConvertError do
      begin
      ShowMessage(Exception.Message);  t1:=1; edit2.Text:=inttostr(t1);
      end;
  end;

if (t1>N_test)or(t1<1) then begin t1:=1; edit2.Text:=inttostr(t1); end;
   for i:=1 to 28 do
    for j:=1 to 28 do
       Maskk2[i,j]:= Test_data[t1][(j-1)*28+i];
Label3.Caption:=inttostr( Test_label[t1]);
Draw_Digit;

end;

procedure TForm1.Load_Tpattern_buttonClick(Sender: TObject); //Loading T-Pattern files 
begin
Label_Load_T.Font.Color:=clAqua;  Application.ProcessMessages;
sleep(1000);
AssignFile(logFile, 'VMproect\'+edit3.text+'.VM');

if  FileExists('VMproect\'+edit3.text+'.VM') then
begin
  Reset(logFile);
  Readln(logFile,KX);
  for ii:=1 to KX do
  begin
    Readln(logFile,VM[ii][1],VM[ii][2]);
  end;
  CloseFile(logFile);
end
  else begin Showmessage('No File'); okk:=false; end;

Label_Load_T.Font.Color:=clBlack;  Application.ProcessMessages;
end;

procedure TForm1.Start_buttonClick(Sender: TObject); //Starting the program
begin
try
P_max:=strtoint(P_number.text);  //Setting the number of neurons in hidden layer
  except
    on Exception : EConvertError do
      begin
      ShowMessage(Exception.Message);  P_max:=25; P_number.text:=inttostr(P_max);
      end;
  end;
if (P_max>P_maximum) or (P_max<1) then begin P_max:=25; P_number.text:=inttostr(P_max);end;
label8.Caption:='N_test='+inttostr(N_test)+'   N_train='+inttostr(N_train)+
'   Y_max='+inttostr(Y_max)+ '   P_max='+inttostr(P_max)+'   N_max='+inttostr(N_max);
Label_name.caption:='LogNNet-784:'+inttostr(P_max)+':10';
Application.ProcessMessages;
Start_button.Enabled:=false;
View_train.Enabled:=false;
View_test.Enabled:=false;
stop:=false;
old_time2:=now;    // variable for determining calculation time
Label7.Caption:='---';   Label13.Caption:='---';    Label15.Caption:='---';
if LoadFirsttime_Mnist then Load_mnist_button.Click;  // Loading training Train_data, test data Test_data 
Zeroing;
Load_Tpattern_button.Click;  // Loading T-Pattern files
if not okk then begin Start_button.Enabled:=true; exit; end;
Setting_Array_W1.Click; // The initial values of the elements
Fh_activ_fun_parameters.Click;  //Calculation of auxiliary data for normalizing the values of the hidden layer
EpochTraining.Click;   // Training the array W2 using the backpropagation of error method
Algorithm_3.Click;   // Testing the network Algorithm-3
Algorithm_2.Click;   // Testing the network Algorithm-2
Algorithm_1.Click;   // Testing the network Algorithm-1
//Calculation of program execution time
DecodeTime(now-old_time2, myHour, myMin, mySec, myMilli);
All_t:=myMin+myHour*60;
label47.Caption:='Time[min]='+inttostr(All_t);
label48.Caption:='Time[s]='+inttostr(mySec);

Start_button.Enabled:=true;
View_train.Enabled:=true;
View_test.Enabled:=true;
end;

procedure TForm1.EpochTrainingClick(Sender: TObject);  //Training the array W2 using the backpropagation of error method
var
Epoch_number_z1:integer;
begin
Label_Epoch_training.Font.Color:=clAqua;  Application.ProcessMessages;

EpochTraining.Enabled:=false;
old_time:=now;
z1:=0;
Epoch_number_z1:=strtoint(Epoch_number.Text);
repeat
  z1:=z1+1;
  label34.Caption:=inttostr(z1);
  Application.ProcessMessages;
  for z2:=1 to N_train do begin
    if (now-old_time)>Sec1 then  begin Application.ProcessMessages; old_time:=now; end;
    Nom_tren:=z2;
    BackPropagation.Click;  //Training the array W2 using the backpropagation of error method
  end;
until (z1=Epoch_number_z1) or (stop);
EpochTraining.Enabled:=true;
Label_Epoch_training.Font.Color:=clBlack;  Application.ProcessMessages;
end;

Function VM_transform(YYY:InputData):InputData;  // Function for T-pattern transformation

var
tt:integer;
begin
for tt:=1 to  Y_max do
  begin
  VM_transform[tt]:=YYY[(VM[tt][2]-1)*28+VM[tt][1]];
  end;
VM_transform[0]:=1;
end;

 function Normalization(XX:InputData):InputData2; // Function to normalize input data
 var
 t1:integer;
 d1,d2:integer;
 begin
  Normalization[0]:=1; // Bias
  for t1:=1 to Y_max do  Normalization[t1]:=XX[t1]/255;
 end;

 function Fout(R:real):real;   // Logistic activation function for output neurons
 begin
  Fout:=1/(1+exp(-R));
 end;

procedure TForm1.BackPropagationClick(Sender: TObject); //Back-propagation method
begin
Y:=Normalization(VM_transform(Train_data[Nom_tren]));

for j:=1 to P_max do   // matrix multiplication Sh=fh(Y*W1)
begin
  Sh[j]:=0;
  for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];
  Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5)-Usre[j]; // fh is identity activation function,
  //which is normalized in the range from -0.5 to 0.5
end;

Sh[0]:=1;  //bias

for j:=0 to N_max do
begin
  Sout[j]:=0;
  for i:=0 to P_max do Sout[j]:=Sout[j]+Sh[i]*W2[i,j];
  Sout[j]:=Fout(Sout[j]);
end;


for i:=0 to N_max do Err3[i]:=(Train_label2[Nom_tren][i]-Sout[i])*Sout[i]*(1-Sout[i]);

for i:=0 to P_max do
for j:=0 to N_max do
begin
 dW2[i,j]:=Norma*Err3[j]*Sh[i];
 W2[i,j]:=W2[i,j]+dW2[i,j];
end;

end;

procedure TForm1.Setting_Array_W1Click(Sender: TObject);  //Initial Setting Array W1  and W2
begin
Label_Setting_Array.Font.Color:=clAqua;  Application.ProcessMessages;
sleep(1000);
Setting_Array_W1.Enabled:=false;
randomize;
SSS:=edit26.Text;
SSS:=StringReplace(SSS, '.' , DecimalSeparator, [rfIgnoreCase, rfReplaceAll]);
SSS:=StringReplace(SSS, ',' , DecimalSeparator, [rfIgnoreCase, rfReplaceAll]);
r:=strtofloat(SSS);   //Setting r

SSS:=edit28.Text;
SSS:=StringReplace(SSS, '.' , DecimalSeparator, [rfIgnoreCase, rfReplaceAll]);
SSS:=StringReplace(SSS, ',' , DecimalSeparator, [rfIgnoreCase, rfReplaceAll]);
B:=strtofloat(SSS);   //Setting B

SSS:=edit5.Text;
SSS:=StringReplace(SSS, '.' , DecimalSeparator, [rfIgnoreCase, rfReplaceAll]);
SSS:=StringReplace(SSS, ',' , DecimalSeparator, [rfIgnoreCase, rfReplaceAll]);
A:=strtofloat(SSS);    //Setting A

// The initial values of the elements of the first row W1[i][1]
j:=1;
for i:=0 to Y_max do
begin
  W1[i,j]:= A*sin((i/Y_max)*Pi/B);
end;

// Applying (2) to the elements of the weight matrix W1
for j:=2 to P_max do
begin
  for i:=0 to Y_max do
  begin
    W1[i,j]:=(1-r*W1[i,j-1]*W1[i,j-1]);
  end;
end;
//The initial values of the weights W2 are set randomly between -0.5 and 0.5.
for i:=0 to P_max do
  for j:=0 to N_max do  W2[i,j]:=(0.5-Random);

Setting_Array_W1.Enabled:=true;
Label_Setting_Array.Font.Color:=clBlack;  Application.ProcessMessages;
end;

procedure TForm1.Fh_activ_fun_parametersClick(Sender: TObject);  //Calculation of auxiliary data for normalizing the values of the hidden layer
var
pp:integer;
begin
//Auxiliary data for calculating fh and subsequent normalization are
//arrays of maximum Sh_max, minimum Sh_min and average values Usre of the weighted
//sum of the hidden layer for all training data.

Label_Fh_activ_fun_parameters.Font.Color:=clAqua;  Application.ProcessMessages;
sleep(1000);
for j:=0 to P_max do Sh_max[j]:=0;
for j:=0 to P_max do Sh_min[j]:=100;

old_time:=now;
for  Nom_tren:=1 to N_train do
begin
  if (now-old_time)>Sec1 then  begin Application.ProcessMessages; old_time:=now; end;

  Y:=Normalization(Train_data[Nom_tren]);
  Sh[0]:=1;  Sh_max[0]:=1; Sh_min[0]:=1;  //Not used
  for j:=1 to P_max do
  begin
    Sh[j]:=0;
    for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];

    if Sh[j]>Sh_max[j] then Sh_max[j]:=Sh[j];  //Find maximum Sh
    if Sh[j]<Sh_min[j] then Sh_min[j]:=Sh[j];  //Find minimum Sh

  end;
end;


for j:=1 to P_max do
begin
  Usred:=0;
  for Nom_tren:=1 to 1000 do
  begin
    Y:=Normalization(VM_transform(Train_data[Nom_tren]));
    Sh[j]:=0;
    for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];
    Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5);
    Usred:=Usred+ Sh[j];
  end;
Usred:=Usred/1000;
Usre[j]:=Usred;  //average values Usre of the weighted sum of the hidden layer
end;

Label_Fh_activ_fun_parameters.Font.Color:=clBlack;  Application.ProcessMessages;

end;


procedure TForm1.Algorithm_3Click(Sender: TObject);
begin
Label_Alg_3.Font.Color:=clAqua;  Application.ProcessMessages;
sleep(1000);
Algorithm_3.Enabled:=false;
old_time:=now;
Correct_test:=0;
for Nom_tren:=1 to N_test do
begin
  Y:=Normalization(VM_transform(Test_data[Nom_tren]));
  for j:=1 to P_max do // Loop over the neurons of the hidden layer
  begin
    Sh[j]:=0;
    for i:=0 to Y_max do Sh[j]:=Sh[j]+Y[i]*W1[i,j];
    Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5)-Usre[j]; // fh is identity activation function,
    //which is normalized in the range from -0.5 to 0.5
  end;
  Sh[0]:=1;

  for j:=0 to N_max do   // Loop over the neurons of the output layer
  begin
    Sout[j]:=0;
    for i:=0 to P_max do Sout[j]:=Sout[j]+Sh[i]*W2[i,j];
    Sout[j]:=Fout(Sout[j]);
  end;
  i_max:=1;
  For i:=0 to N_max do if Sout[i]>Sout[i_max] then i_max:=i;
  // Counting the number of correct recognitions
  if i_max=Test_label[Nom_tren] then Correct_test:=Correct_test+1;
end;
//Classification accuracy
Accuracy:=(Correct_test/N_test)*100;

DecodeTime(now-old_time, myHour, myMin, mySec, myMilli);
All_t:=myMilli+mySec*1000+ myMin*60*1000;
label43.Caption:='All_t[ms]='+inttostr(All_t);
label44.Caption:='talg3[ms]='+floattostr((All_t/N_test));

label7.Caption:=floattostrf(Accuracy,fffixed,4,2);

Algorithm_3.Enabled:=true;
Label_Alg_3.Font.Color:=clBlack;  Application.ProcessMessages;

end;

procedure TForm1.Stop_buttonClick(Sender: TObject);
begin
stop:=true;
Stop_button.Enabled:=false;
end;

procedure TForm1.Algorithm_2Click(Sender: TObject);
begin
Label_Alg_2.Font.Color:=clAqua;  Application.ProcessMessages;
sleep(1000);
Algorithm_2.Enabled:=false;
old_time:=now;
Correct_test:=0;
for Nom_tren:=1 to N_test do
begin
  Y:=Normalization(VM_transform(Test_data[Nom_tren]));
  for j:=1 to P_max do   // Loop over the neurons of the hidden layer
  begin
    Sh[j]:=0;
    for i:=0 to Y_max do
    begin
      if j=1 then W1_alg2[i]:= A*sin((i/Y_max)*Pi/B) else W1_alg2[i]:=(1-r*W1_alg2[i]*W1_alg2[i]) ;
      Sh[j]:=Sh[j]+Y[i]*W1_alg2[i];
    end;
    Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5)-Usre[j]; // fh is identity activation function,
      //which is normalized in the range from -0.5 to 0.5
  end;
  Sh[0]:=1;

  for j:=0 to N_max do
  begin
    Sout[j]:=0;
    for i:=0 to P_max do Sout[j]:=Sout[j]+Sh[i]*W2[i,j];
    Sout[j]:=Fout(Sout[j]);
  end; //  for j:=1 to P_max do
  i_max:=1;
  For i:=0 to N_max do if Sout[i]>Sout[i_max] then i_max:=i;
  //  counting the right tests
  if i_max=Test_label[Nom_tren] then Correct_test:=Correct_test+1;
end;  //for Nom_tren:=1 to Nset do

//classification accuracy
Accuracy:=(Correct_test/N_test)*100;

DecodeTime(now-old_time, myHour, myMin, mySec, myMilli);
All_t:=myMilli+mySec*1000+ myMin*60*1000;
label9.Caption:='All_t[ms]='+inttostr(All_t);
label1.Caption:='talg2[ms]='+floattostr((All_t/N_test));
label13.Caption:=floattostrf(Accuracy,fffixed,4,2);

Algorithm_2.Enabled:=true;
Label_Alg_2.Font.Color:=clBlack;  Application.ProcessMessages;
end;

procedure TForm1.Algorithm_1Click(Sender: TObject);
begin
Label_Alg_1.Font.Color:=clAqua;  Application.ProcessMessages;
sleep(1000);
Algorithm_1.Enabled:=false;
old_time:=now;
Correct_test:=0;
old_time2:=now;
for Nom_tren:=1 to N_test do
begin
  if (now-old_time2)>Sec1 then  begin label23.Caption:=inttostr(Nom_tren);  Application.ProcessMessages; old_time2:=now; end;
  Y:=Normalization(VM_transform(Test_data[Nom_tren]));
  for j:=1 to P_max do
  begin
    Sh[j]:=0;
    for i:=0 to Y_max do
    begin
      W1_alg1:= A*sin((i/Y_max)*Pi/B);
      for k:=2 to j do W1_alg1:=(1-r*W1_alg1*W1_alg1) ;
      Sh[j]:=Sh[j]+Y[i]*W1_alg1;
    end;
  Sh[j]:=((Sh[j]-Sh_min[j])/(Sh_max[j]-Sh_min[j])-0.5)-Usre[j]; // fh is identity activation function,
  //which is normalized in the range from -0.5 to 0.5
  end;
  Sh[0]:=1;

  for j:=0 to N_max do
  begin
    Sout[j]:=0;
    for i:=0 to P_max do Sout[j]:=Sout[j]+Sh[i]*W2[i,j];
    Sout[j]:=Fout(Sout[j]);
  end;
  i_max:=1;
  For i:=0 to N_max do if Sout[i]>Sout[i_max] then i_max:=i;
  //  counting the right tests
  if i_max=Test_label[Nom_tren] then Correct_test:=Correct_test+1;

end;  //for Nom_tren:=1 to Nset do
//classification accuracy
Accuracy:=(Correct_test/N_test)*100;

DecodeTime(now-old_time, myHour, myMin, mySec, myMilli);
All_t:=myMilli+mySec*1000+ myMin*60*1000;
label11.Caption:='All_t[ms]='+inttostr(All_t);
label10.Caption:='talg1[ms]='+floattostr((All_t/N_test));
label15.Caption:=floattostrf(Accuracy,fffixed,4,2);

Algorithm_1.Enabled:=true;
Label_Alg_1.Font.Color:=clBlack;
label23.Caption:=inttostr(N_test);
Application.ProcessMessages;
end;

end.
